##
##format long;
### format short;

pkg load optim
pkg load matgeom

printf('\n');

disp(" Exemplo de uma entrada da função H com 2 parâmetros");
disp(" @(theta, x) theta(1) * exp (theta(2) * x) ");

printf('\n');

funcao = input(' Digite a funcao H = ',"s");

H = str2func(funcao);

printf('\n\n');

disp(" Exemplo de um vetor inicial com 2 parâmetros");
disp(" [1.4; -1.8] ");

printf('\n');

init = input(' Digite o vetor de parâmetros iniciais theta = ');

##Método de Newton
[theta] = nonlin_curvefit (H, init, xdata, ydata);


# Cálculo da soma do quadrado dos desvios
d = ydata - H(theta,xdata);
SQD = (vectorNorm(d))^2.0;



n = length(xdata);
nos = abs(xdata(n) - xdata(1))/0.001 + 1;
xx = linspace (xdata(1), xdata(n), nos);



# Cálculo da determinação
ymedia = sum(ydata)/n;
VAREXPLICADO = 0.0;
VARTOTAL = 0.0;
for i = 1:n

       yestimado = H(theta,xdata(i));
    VAREXPLICADO = VAREXPLICADO + (yestimado - ymedia)^2.0;
        VARTOTAL = VARTOTAL + (ydata(i) - ymedia)^2.0;
endfor
COEFDET = VAREXPLICADO / VARTOTAL ;



printf('\n\n\n');
printf('Parametros determinados para o ajuste em Mínimos Quadrados Nao Linear (Met. de Newton):\n');
printf('----------------------------\n');

printf('theta\n');
printf('        % 6.8e \n',theta);

printf('\n');

printf('Soma do quadrado dos desvios\n');
printf('        % 6.8e \n',SQD);

printf('\n');

printf('Coeficiente de determinacao\n');
printf('        %f \n',COEFDET);

printf('\n');




plot (xx,H(theta,xx),"r-","linewidth",2,xdata,ydata,"b.","markersize", 20);
xlabel ("x");
ylabel ("y(x)          ");
set(get(gca,'ylabel'),'Rotation',0)
title ("Gráfico","fontsize", 20);
h = legend ("Equacao via MMQNL","Dados","location", "southoutside", "orientation", "horizontal");
set(h, "fontsize", 15)
legend boxoff;


