
format long;
# format short;

n = length(xdata) - 1;


# cálculo dos espacamentos entre pontos do dominio
for k = 2:(n+1)
                     
    h(k) = xdata(k) .- xdata(k-1);

endfor


# montagem da diagonal principal (DP), do termo independente (TI) e das diagonais superior (DS) e inferior (DI) respectivamente
for k = 2:n
                     
        DP(k) = 2.0 .* ( h(k) + h(k+1) );
        
        TI(k) = 6.0 .* ( ydata(k+1) - ydata(k) ) ./ h(k+1) - 6.0 .* ( ydata(k) - ydata(k-1) ) ./ h(k);

#         if ( (k>1) && (k<=n) )

        DS(k) = h(k+1);
                    
#         endif
        
#         if ( (k>=2) && (k<=n) )

        DI(k) = h(k);
                    
#         endif
    
endfor



# Eliminação

w(2) = DP(2);

q(2) = DS(2) ./ w(2);

fi(2) = TI(2) ./ w(2);

for k = 3:(n-1)
                     
    w(k) = DP(k) - DI(k) .* q(k-1);
        
    q(k) = DS(k) ./ w(k);
    
    fi(k) = ( TI(k) .- DI(k) .* fi(k-1) ) ./ w(k);
    
endfor

w(n) = DP(n) - DI(n) .* q(n-1);

fi(n) = ( TI(n) .- DI(n) .* fi(n-1) ) ./ w(n);


# Substituição

g(n) = fi(n);

for k = (n-1):-1:2
                     
    g(k) = fi(k) - q(k) .* g(k+1);
        
endfor


# Spline Natural

g(1)   = 0.0;   g(n+1) = 0.0;


# Cálculo dos coeficientes dos polinomios cubicos
for k = 2:(n+1)
                     
    a(k) = ( g(k) - g(k-1) ) ./ (6.0 .* h(k));
    
    b(k) = g(k) ./ 2.0;
    
    c(k) = ( ydata(k) - ydata(k-1) ) ./ h(k) + ( 2.0 .* h(k) .* g(k) + g(k-1) .* h(k) ) ./ 6.0;
    
    d(k) = ydata(k);
        
endfor


nos = abs(xdata(n+1) - xdata(1))./0.0001 + 1; 

x = linspace (xdata(1), xdata(n+1), nos);

nn = length(x);


k = 1; i = 1;

while (i <= nn)
   
    if ( ( xdata(k) <= x(i) ) && ( x(i) <= xdata(k+1) ) )
    
        SCI(i) = a(k+1).*( x(i).-xdata(k+1) ).^3.0 + b(k+1).*( x(i).-xdata(k+1) ).^2.0 + c(k+1).*( x(i).-xdata(k+1) ) + d(k+1);
        
        i = i + 1;
        
    else
        
        k = k + 1;

    endif

endwhile



printf('\n\n\n');
printf('Parametros da Spline Cúbica Natural:\n');
printf('----------------------------\n');

printf('SCI(x) = a *( x - xdata(k) )^3 +b *( x - xdata(k) )^2 +c *( x - xdata(k) ) +d\n');

coeficientes=[a(2:n+1); b(2:n+1); c(2:n+1); d(2:n+1)];
#printf('        % 6.8e        % 6.8e        % 6.8e      % 6.8e\n',coeficientes);
disp(coeficientes);

printf('\n');


#hf = figure ();
plot (x,SCI,"r-","linewidth",2,xdata,ydata,"b.","markersize", 15);
xlabel ("x");
ylabel ("SCI(x)          ");
set(get(gca,'ylabel'),'Rotation',0)
#title ("Gráfico","fontsize", 20);
h = legend ("Spline Cubico Natural","Dados","location", "southoutside", "orientation", "horizontal");
set(h, "fontsize", 15)
legend boxoff;
#print (hf, "SplineCubico.pdf", "-dpdflatexstandalone");
#system ("pdflatex SplineCubico");
#open SplineCubico.pdf
#print (hf,"-r600", "SplineCubico.png");
#open SplineCubico.png
#saveas (hf, "SplineCubico.png");
#open SplineCubico.png
