
clc;
pkg load symbolic
pkg load optim
pkg load matgeom


xdata = [-2  -1  0  1      2   3    4   5   6    7 ];
ydata = [10   8  4  3.5  2.1   1  0.5 0.3 0.2  0.1 ];

##xdata = [-1, 0, 1, 1.5];
##ydata = [8.0, 1.5, 0.2, 0.1];




n = length(xdata);
nos = abs(xdata(n) - xdata(1))/0.001 + 1;
xx = linspace (xdata(1), xdata(n), nos);

mu_1 = exp(1.51053467e+00);
mu_2 = - (-5.26058736e-01);

##mu_1 = exp(3.15179060e-01)
##mu_2 = - (-1.79188840e+00)




syms x ;

P = @(x) mu_1 * exp( - mu_2 * x );

# Cálculo da determinação
ymedia = sum(ydata)/n;
VAREXPLICADO = 0.0;
VARTOTAL = 0.0;
for i = 1:n

       yestimado = P(xdata(i));
    VAREXPLICADO = VAREXPLICADO + (yestimado - ymedia)^2.0;
        VARTOTAL = VARTOTAL + (ydata(i) - ymedia)^2.0;
endfor
COEFDET_P = VAREXPLICADO / VARTOTAL ;


# Cálculo da soma do quadrado dos desvios
d = ydata - P(xdata);
SQD_P = (vectorNorm(d))^2.0;






H = @(theta, x) theta(1) * exp (theta(2) * x);

init = [1.4; -1.8]

##Método de Newton
[theta] = nonlin_curvefit (H, init, xdata, ydata);

# Cálculo da determinação
ymedia = sum(ydata)/n;
VAREXPLICADO = 0.0;
VARTOTAL = 0.0;
for i = 1:n

       yestimado = H(theta,xdata(i));
    VAREXPLICADO = VAREXPLICADO + (yestimado - ymedia)^2.0;
        VARTOTAL = VARTOTAL + (ydata(i) - ymedia)^2.0;
endfor
COEFDET_H = VAREXPLICADO / VARTOTAL ;


# Cálculo da soma do quadrado dos desvios
dd = ydata - H(theta,xdata);
SQD_H = (vectorNorm(dd))^2.0;



mu = [mu_1 mu_2];

printf('mu\n');
printf('        % 6.8e \n',mu);

printf('theta\n');
printf('        % 6.8e \n',theta);

##printf('Coeficiente de determinacao\n');
##printf('        %f %f\n',COEFDET_P,COEFDET_H);

printf('Soma do quadrado dos desvios\n');
printf('        %6.8e %6.8e\n',SQD_P,SQD_H);

printf('\n');



plot (xx,P(xx),"g-","linewidth",2,xx,H(theta,xx),"r-","linewidth",2,xdata,ydata,"b.","markersize", 20);
xlabel ("x");
ylabel ("y(x)          ");
set(get(gca,'ylabel'),'Rotation',0)
title ("Comparação gráfica","fontsize", 20);
h = legend ("Equacao via MMQL","Equacao via MMQNL","Dados","location", "southoutside", "orientation", "horizontal");
set(h, "fontsize", 15)
legend boxoff;



